
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.PrintStream;
import java.net.Socket;
import java.util.Date;
import java.util.Vector;

/**
 * Title: HappyChatϵͳ
 * @version 1.0
 */
public class Connection extends Thread {
	/**
	 * ͻͨѶSocket
	 */
	private Socket netClient;

	/**
	 * ûб
	 */
	private Vector<Customer> userOnline;

	/**
	 * Ϣ
	 */
	private Vector<Chat> userChat;

	/**
	 * ӿͻ 
	 */
	private ObjectInputStream fromClient;

	/**
	 * ͻ ӡ
	 */
	private PrintStream toClient;

	/**
	 * עûб
	 */
	private static Vector vList = new Vector();

	/**
	 * ʱ
	 */
	private Object obj;

	/**
	 * ־
	 */
	private ServerFrame sFrame;

	@SuppressWarnings("unchecked")
	/**
	 * ͻͨѶ
	 */
	public Connection(ServerFrame frame, Socket client, Vector u, Vector c) {
		netClient = client;
		userOnline = u;
		userChat = c;
		sFrame = frame;
		try {
			// ˫ͨ
			// ͻ
			fromClient = new ObjectInputStream(netClient.getInputStream());
			
			// дͻ
			toClient = new PrintStream(netClient.getOutputStream());
		} catch (IOException e) {
			try {
				netClient.close();
			} catch (IOException e1) {
				System.out.println("ܽ" + e1);
				return;
			}
		}
		this.start();
	}

	/**
	 * ͻ˵ͨѶ߳
	 */
	public void run() {
		try {// objObjectĶ
			obj = (Object) fromClient.readObject();
			if (obj.getClass().getName().equals("Customer")) {
				serverLogin();
			}
			if (obj.getClass().getName().equals("Register_Customer")) {
				serverRegiste();
			}
			if (obj.getClass().getName().equals("Message")) {
				serverMessage();
			}
			if (obj.getClass().getName().equals("Chat")) {
				serverChat();
			}
			if (obj.getClass().getName().equals("Exit")) {
				serverExit();
			}
		} catch (IOException e) {
			System.out.println(e);
		} catch (ClassNotFoundException e1) {
			System.out.println("" + e1);
		} finally {
			try {
				netClient.close();
			} catch (IOException e) {
				System.out.println(e);
			}
		}
	}

	/**
	 * 
	 * ¼
	 */
	@SuppressWarnings("deprecation")
	public void serverLogin() {

		try {
			Customer clientMessage2 = (Customer) obj;
			// ļ
			FileInputStream file3 = new FileInputStream("user.txt");
			ObjectInputStream objInput1 = new ObjectInputStream(file3);
			vList = (Vector) objInput1.readObject();

			int find = 0; // жϱ־
			for (int i = 0; i < vList.size(); i++) {
				Register_Customer reg = (Register_Customer) vList.elementAt(i);

				if (reg.custName.equals(clientMessage2.custName)) {
					find = 1;
					if (!reg.custPassword.equals(clientMessage2.custPassword)) {
						toClient.println("벻ȷ");
						break;
					} else {
						// жǷѾ¼
						int login_flag = 0;
						for (int a = 0; a < userOnline.size(); a++) {
							String _custName = ((Customer) userOnline
									.elementAt(a)).custName;
							if (clientMessage2.custName.equals(_custName)) {
								login_flag = 1;
								break;
							}
						}

						if (userOnline.size() >= 50) {
							toClient.println("¼࣬Ժ");
							break;
						}

						if (login_flag == 0) {
							clientMessage2.custHead = reg.head;// getUserHeadByName(clientMessage2.custName);
							userOnline.addElement(clientMessage2);
							// // û
							toClient.println("¼ɹ");
							Date t = new Date();
							log("û" + clientMessage2.custName + "¼ɹ"
									+ "¼ʱ:" + t.toLocaleString() + "\n\n");
							freshServerUserList();
							break;
						} else {
							toClient.println("ûѵ¼");
						}
					}
				} else {
					continue;
				}
			}
			if (find == 0) {
				toClient.println("ûûע");
			}

			file3.close();
			objInput1.close();
			fromClient.close();
		} catch (ClassNotFoundException e) {
			System.out.println(e);
		} catch (IOException e) {
			System.out.println(e);
		}
	}

	/**
	 * ˢ·־б
	 * 
	 */
	private void freshServerUserList() {
		String[] userList = new String[50];
		Customer cus = null;
		for (int j = 0; j < userOnline.size(); j++) {
			cus = (Customer) userOnline.get(j);
			userList[j] = cus.custName;
		}
		sFrame.list.setListData(userList);
		sFrame.txtNumber.setText("" + userOnline.size());
		sFrame.lblUserCount.setText("ǰ:" + userOnline.size());
	}

	/**
	 * עᴦ
	 */
	@SuppressWarnings( { "unchecked", "deprecation" })
	public void serverRegiste() {
		try {
			int flag = 0; // Ƿжϱ־
			Register_Customer clientMessage = (Register_Customer) obj;
			File fList = new File("user.txt");
			if (fList.length() != 0)// жǷǵһעû
			{
				ObjectInputStream objInput = new ObjectInputStream(
						new FileInputStream(fList));
				vList = (Vector) objInput.readObject();
				// жǷ
				for (int i = 0; i < vList.size(); i++) {
					Register_Customer reg = (Register_Customer) vList
							.elementAt(i);
					if (reg.custName.equals(clientMessage.custName)) {
						toClient.println("עظ,ѡ");
						flag = 1;
						break;
					} else if (reg.custName.equals("")) {
						toClient.println("ֹʹôע,ѡ");
						flag = 1;
						break;
					}
				}
			}
			if (flag == 0) {
				// עû
				vList.addElement(clientMessage);
				// едļ
				FileOutputStream file = new FileOutputStream(fList);
				ObjectOutputStream objout = new ObjectOutputStream(file);
				objout.writeObject(vList);

				// עɹϢ
				toClient.println(clientMessage.custName + "עɹ");
				Date t = new Date();
				log("û" + clientMessage.custName + "עɹ, " + "עʱ:"
						+ t.toLocaleString() + "\n\n");
				file.close();
				objout.close();
				fromClient.close();
			}
		} catch (ClassNotFoundException e) {
			System.out.println(e);
		} catch (IOException e) {
			System.out.println(e);
		}
	}

	/**
	 * Ϣ
	 */
	public void serverMessage() {
		try {
			Message mess = new Message();
			mess.userOnLine = userOnline;
			mess.chat = userChat;
			mess.serverMessage = "" + sFrame.serverMessage;

			ObjectOutputStream outputstream = new ObjectOutputStream(netClient
					.getOutputStream());
			outputstream.writeObject((Message) mess);

			netClient.close();
			outputstream.close();
		} catch (IOException e) {
		}

	}

	/**
	 * Ϣ
	 */
	public void serverChat() {
		// յĶֵϢл
		Chat cObj = new Chat();
		cObj = (Chat) obj;

		chatLog(cObj);

		// ϢлӵϢʸ

		userChat.addElement((Chat) cObj);
		return;
	}

	/**
	 * û˳
	 */
	@SuppressWarnings("deprecation")
	public void serverExit() {
		Exit exit = new Exit();
		exit = (Exit) obj;

		removeUser(exit);
		Date t = new Date();

		log("û" + exit.exitname + "Ѿ˳, " + "˳ʱ:" + t.toLocaleString());

		freshServerUserList();
	}

	/**
	 * ûɾ˳û
	 * 
	 * @param exit ˳û
	 */
	private void removeUser(Exit exit) {
		Vector<Customer> vec = new Vector<Customer>();
		Customer _cus = null;
		for (int j = 0; j < userOnline.size(); j++) {
			_cus = (Customer) userOnline.get(j);
			if (!exit.exitname.equals(_cus.custName)) {
				vec.add(_cus);
			}
		}
		userOnline.removeAllElements();
		for (int j = 0; j < vec.size(); j++) {
			_cus = (Customer) vec.get(j);
			userOnline.add(_cus);
		}

	}

	/**
	 * ־д Ϣ
	 * @param log ־Ϣ
	 */
	public void log(String log) {
		String newlog = sFrame.taLog.getText() + "\n\n" + log;
		sFrame.taLog.setText(newlog);
	}

	/**
	 * 	
	 * ־д Ϣ
	 * @param obj  Ϣ
	 */
	@SuppressWarnings("deprecation")
	public void chatLog(Chat obj) {
		String newlog = sFrame.taMessage.getText();
		Date date = new Date();
		if (!obj.whisper) {
			newlog += "\n";
			newlog += ("[" + date.getHours() + ":" + date.getMinutes() + ":"
					+ date.getSeconds() + "]");
			newlog += obj.chatUser;
			newlog += "->";
			newlog += obj.chatToUser;
			newlog += ":";
			newlog += obj.chatMessage;
		}
		sFrame.taMessage.setText(newlog);
	}
}